---
title: XPathEvaluator.createExpression()
slug: Web/API/XPathEvaluator/createExpression
tags:
  - API
  - DOM
  - DOM XPath API
  - Method
  - Reference
  - XPath
  - XPathEvaluator
---
<div>{{APIRef("DOM XPath")}}</div>

<p>This method compiles an {{domxref("XPathExpression")}} which can then be used for (repeated) evaluations of the {{Glossary("XPath")}} expression.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>XPathExpression</var> <var>XPathEvaluator</var>.createExpression(<var>expression</var>, <var>resolver</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>expression</dt>
 <dd>A {{domxref("DOMString")}} representing the XPath expression to be created.</dd>
 <dt>resolver {{optional_inline}}</dt>
 <dd>Permits translation of all prefixes, including the <code>xml</code> namespace prefix, within the XPath expression into appropriate namespace URIs.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("XPathExpression")}} representing the compiled form of the XPath expression.</p>

<h3 id="Exceptions">Exceptions</h3>

<h4 id="INVALID_EXPRESSION_ERR">INVALID_EXPRESSION_ERR</h4>

<p>If the expression is not legal according to the rules of the <code>XPathEvaluator</code>, an {{domxref("XPathException")}} of type <code>INVALID_EXPRESSION_ERR</code> is raised.</p>

<h4 id="NAMESPACE_ERR">NAMESPACE_ERR</h4>

<p>If the expression contains namespace prefixes which cannot be resolved by the specified {{domxref("XPathNSResolver")}}, a {{domxref("DOMException")}} of type <code>NAMESPACE_ERROR</code> is raised.</p>

<h2 id="Example">Example</h2>

<p>The following example shows the use of the <code>evaluate()</code> method.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div&gt;XPath example&lt;/div&gt;
&lt;div&gt;Number of &amp;lt;div&amp;gt;s: &lt;output&gt;&lt;/output&gt;&lt;/div&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">var xpath = "//div";
var evaluator = new XPathEvaluator();
var expression = evaluator.createExpression("//div");
var result = expression.evaluate(document, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE);
document.querySelector("output").textContent = result.snapshotLength;
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example', 400, 70)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 XPath", "xpath.html#XPathEvaluator-createExpression", "XPathEvaluator.createExpression()")}}</td>
   <td>{{Spec2("DOM3 XPath")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XPathEvaluator.createExpression")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("Document.createExpression()")}}</li>
 <li>{{DOMxRef("XPathExpression")}}</li>
</ul>
